define('aim/capacity/view/CapacityValueView',['aim/capacity/view/SelectResourceView',
                                     'aim/capacity/view/SelectFromView',
                                     'aim/capacity/view/SelectToView',
                                     'aim/capacity/view/ExtendFilterView'], function(
                                    		 SelectResourceView,
                                    		 SelectFromView,
                                    		 SelectToView,
                                    		 ExtendFilterView) {
	var CapacityValueView = Backbone.View.extend({
		
		el : '#add-capacity-dialog',
		
		events: {
			"change #resource-single-select" : "resourceSelectChanged",
			"click  #resource-single-select" : "resourceSelectSelected",
			"change #fromDate" : "fromChanged",
			"change #toDate" : "toChanged",
			"change #monday" : "mondayValueChanged",
			"change #tuesday" : "tuesdayValueChanged",
			"change #wednesday" : "wednesdayValueChanged",
			"change #thursday" : "thursdayValueChanged",
			"change #friday" : "fridayValueChanged",
			"change #saturday" : "saturdayValueChanged",
			"change #sunday" : "sundayValueChanged",
			"click #capacityvalues-save-button" : "saveCapacityValues",
			"click #capacityvalues-cancel-button" : "cancelCapacityValues"
		},
		
		initialize : function() {
			var capacityModel = this.model.get('capacityValueModel');
			capacityModel.fetch();
			this.listenTo(capacityModel, 'sync', this.render);

			var selectResourceView = new SelectResourceView({model: capacityModel});
			var selectedFromDate = new SelectFromView({model: capacityModel});
			var selectedToDate = new SelectToView({model: capacityModel});
			var extendFilterView = new ExtendFilterView({model: capacityModel});
		},
		
		render : function() {
			var capacityModel = this.model.get('capacityValueModel');
			AJS.$("#monday").attr("value", capacityModel.get('mondayValue'));
			AJS.$("#tuesday").attr("value", capacityModel.get('tuesdayValue'));
			AJS.$("#wednesday").attr("value", capacityModel.get('wednesdayValue'));
			AJS.$("#thursday").attr("value", capacityModel.get('thursdayValue'));
			AJS.$("#friday").attr("value", capacityModel.get('fridayValue'));
			AJS.$("#saturday").attr("value", capacityModel.get('saturdayValue'));
			AJS.$("#sunday").attr("value", capacityModel.get('sundayValue'));
			return this;		
		},
		
		saveCapacityValues : function() {
			if(this.model.get('capacityValueModel').get('selectedResource') == 0)
				return this;
			var that = this;
			var capacityModel = this.model.get('capacityValueModel');
			capacityModel.set('operation', "spreadInPeriod");
			capacityModel.set('saved', "true");
			capacityModel.save(null, {success:function(model, res, options) {
				that.model.get('capacityValueModel').fetch();
				that.model.get('newFilterModel').fetch();	
				that.model.get('contextModel').fetch();	
			}});
			AJS.dialog2("#add-capacity-dialog").hide();
		},

		cancelCapacityValues : function() {
			AJS.dialog2("#add-capacity-dialog").hide();
			this.model.get('capacityValueModel').fetch();
		},
		
		fromChanged : function(event) {
			var capacityValueModel = this.model.get('capacityValueModel');
			var value = event.currentTarget.value;
			capacityValueModel.set('from', value);
			capacityValueModel.set('selectedFromChanged', "true");
			capacityValueModel.save();
		},
		
		toChanged : function(event) {
			var capacityValueModel = this.model.get('capacityValueModel');
			var value = event.currentTarget.value;
			capacityValueModel.set('to', value);
			capacityValueModel.set('selectedToChanged', "true");
			capacityValueModel.save();
		},
		
		mondayValueChanged : function(event) {
			this.model.get('capacityValueModel').set('mondayValue', event.currentTarget.value);
		},

		tuesdayValueChanged : function(event) {
			this.model.get('capacityValueModel').set('tuesdayValue', event.currentTarget.value);
		},

		wednesdayValueChanged : function(event) {
			this.model.get('capacityValueModel').set('wednesdayValue', event.currentTarget.value);
		},

		thursdayValueChanged : function(event) {
			this.model.get('capacityValueModel').set('thursdayValue', event.currentTarget.value);
		},

		fridayValueChanged : function(event) {
			this.model.get('capacityValueModel').set('fridayValue', event.currentTarget.value);
		},

		saturdayValueChanged : function(event) {
			this.model.get('capacityValueModel').set('saturdayValue', event.currentTarget.value);
		},

		sundayValueChanged : function(event) {
			this.model.get('capacityValueModel').set('sundayValue', event.currentTarget.value);
		},

		resourceSelectSelected : function(event) {
			var options = event.currentTarget.selectedOptions;
			AJS.$('#resource-single-select').focus();
		},

		resourceSelectChanged : function(event) {
//			var capacityValueModel = this.model.get('capacityValueModel');
//			var value = event.currentTarget.value;
//			capacityValueModel.set('selectedResource', value);	
//			capacityValueModel.set('selectedResourceChanged', "true");
//			capacityValueModel.save();

			if(event.added){
				var value = event.added.id;
				this.model.get('capacityValueModel').set('selectedResource', value);	
				this.model.get('capacityValueModel').set('selectedResourceChanged', "true");
				this.model.get('capacityValueModel').save();
			}else if(event.removed){
				var value = 0;
				this.model.get('capacityValueModel').set('selectedResource', value);	
				this.model.get('capacityValueModel').set('selectedResourceChanged', "true");
				this.model.get('capacityValueModel').save();
			}
		}
	});

	return CapacityValueView;
});